/*************************************************************************/
/*************************************************************************/
/* H. Timucin OZDEMIR                                                    */
/* Date : May, 1997                                                      */
/* File Name : AirFileReader1.cc                                         */
/*************************************************************************/
/*************************************************************************/

#include <stdio.h>
#include <stdlib.h>
#include <iostream.h>
#include <fstream.h>

#include "AirFileReader1.h"
#include "FlightSchedule.h"
#include "CityList.h"

/*
//
*/

AirFileReader1::AirFileReader1()
{  sprintf(FileName,"%s","input.air"); 
}// end of constructor

/*
//
*/

AirFileReader1::~AirFileReader1()
{  cout << " de allocate AirFileReader1 " << endl; 
}// end of constructor

/*
//
*/

AirFileReader1::AirFileReader1(char *_fileName)
{  sprintf(FileName,"%s",_fileName); 
   printf("File name is %s",_fileName); 
}// end of constructor

/*
//
*/

void AirFileReader1::setFileName(char *_fileName)
{  sprintf(FileName,"%s",_fileName); 
}// end of constructor

/*
//
*/
/*
AirScheduleProblem AirFileReader1::read()
{  AirScheduleProblem ret;
   unsigned FlightNumber = 0;

   char source[50], destination[50], day[4], flightNumber[15];
   char departureTime[10], arrivalTime[10], AirCraftType[10];
   int i=1;

   ifstream fileIn(FileName);

   cout << " File name is " << FileName << endl;

   while(!fileIn.eof())
   {
      fileIn >> source >> destination >> departureTime;
      fileIn >> arrivalTime >> flightNumber >> AirCraftType;

      if(!fileIn.eof()) 
      {  
	 Date Arr(arrivalTime);
         Date Dep(departureTime);
         unsigned src = ret.lookUp(source);
         unsigned dst = ret.lookUp(destination);
         Flight k(src,dst,FlightNumber,Arr,Dep,0,flightNumber);
         ret.addFlight(k);
	 FlightNumber++;

         cout << source << " ";
	 cout << destination << " ";
	 cout << departureTime << " ";
	 cout << arrivalTime << " ";
	 cout << Dep << Arr << endl;

      }// end of if

   }// end of while

   ret.updateFlightNumbers();
   fileIn.close();

   ret.updateGraph();

   cout << " I finished reading !! " << endl;

   return ret;

}// end of read()
*/

/*
//
*/
/*
void AirFileReader1::read(AirScheduleProblem& ret)
{ 
   char source[50], destination[50], day[4], flightNumber[15];
   char departureTime[10], arrivalTime[10], AirCraftType[10];
   int i=1;
   char buf[500];
   unsigned FlightNumber = 0;

   ifstream fileIn(FileName);

   cout << " File name is " << FileName << endl;

   while(!fileIn.eof())
   {
      //fileIn >> source >> destination >> departureTime;
      //fileIn >> arrivalTime >> flightNumber ;//>> AirCraftType;
 
      fileIn.getline(buf,499);

      istsrstream inp(buf,500);

      inp >> source >> destination >> departureTime;
      inp >> arrivalTime >> flightNumber ;//>> AirCraftType;

      if(!fileIn.eof()) 
      {  
	 Date Arr(arrivalTime);
         Date Dep(departureTime);
         unsigned src = ret.lookUp(source);
         unsigned dst = ret.lookUp(destination);
         Flight k(src,dst,FlightNumber,Arr,Dep,0,flightNumber);
         ret.addFlight(k);
	 FlightNumber++;

         cout << source << " ";
	 cout << destination << " ";
	 cout << departureTime << " ";
	 cout << arrivalTime << " ";
	 cout << Dep << Arr << endl;

      }// end of if

   }// end of while

   ret.updateFlightNumbers();
   fileIn.close();

   ret.updateGraph();

   cout << " I finished reading !! " << endl;

}// end of read()
*/

/*
//
*/

void AirFileReader1::read(FlightSchedule& ret, CityList& cities)
{ 
   char source[50], destination[50], flightNumber[15];
   char departureTime[10], arrivalTime[10], AirCraftType[70];
   char oprator[250];
   unsigned FlightNumber = 0;

   int *inComing = new int[200];

   int *outGoing = new int[200];

   int i;

   for(i=0;i<200;i++) { inComing[i] = 0; outGoing[i] = 0; }

   ifstream fileIn(FileName);

   cout << " File name is " << FileName << endl;

   while(!fileIn.eof())
   {
      fileIn >> source >> destination >> departureTime;
      fileIn >> arrivalTime >> flightNumber >> AirCraftType ;
      //fileIn.getline(oprator,249);
     

      if(!fileIn.eof()) 
      {  
	     Date Arr(arrivalTime);
         Date Dep(departureTime);
         unsigned src = cities.getCityIndex(source);
         unsigned dst = cities.getCityIndex(destination);
         Flight k(src,dst,FlightNumber,Arr,Dep,AirCraftType,flightNumber);

         if(ret.addFlight(k))
         {
            inComing[dst]++;      
            outGoing[src]++;      
	        FlightNumber++;

            cout << "      source : " << source << " " << endl;
	        cout << " destination : " << destination << " " << endl;
	        cout << " depr. time  : " << departureTime << " " << endl;
	        cout << " arrr. time  : " << arrivalTime << " " << endl;
         }

      }// end of if

   }// end of while


   ret.sort();
   //ret.updateFlightNumbers();
   fileIn.close();

   //ret.updateGraph();

   ofstream out("graph");

   out << cities << endl << endl;
   int tt=0;
   
   for(i=0;i<cities.getNumberOfCities();i++) 
   { 
      if( inComing[i] != 0 || outGoing[i] != 0 )
      out << setw(4) << i 
           << setw(5) << inComing[i] 
           << setw(5) << outGoing[i] 
           << setw(5) << minimum(outGoing[i],inComing[i]) << endl;
    
      tt += minimum(outGoing[i],inComing[i]) ;

   }// end of for

   out << endl << " Possible " << tt << " flights!! " << endl;

   out.close();

   cout << " I finished reading !! " << endl;

}// end of read()

